package betterwithmods.common.items.tools;

import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.projectile.EntityArrow;
import net.minecraft.init.Enchantments;
import net.minecraft.init.Items;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemArrow;
import net.minecraft.item.ItemBow;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.StatList;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.SoundCategory;
import net.minecraft.world.World;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;

/**
 * Purpose:
 *
 * @author Tyler Marshall
 * @version 11/18/16
 */
public class ItemCompositeBow extends ItemBow {
    public ItemCompositeBow() {
        this.func_77625_d(1);
        this.func_77656_e(576);
        this.func_185043_a(new ResourceLocation("pull"), (stack, worldIn, entityIn) -> {
            if (entityIn == null) {
                return 0.0F;
            } else {
                ItemStack itemstack = entityIn.func_184607_cu();
                return !itemstack.func_190926_b() && itemstack.func_77973_b() == this ? (float) (stack.func_77988_m() - entityIn.func_184605_cv()) / 20.0F : 0.0F;
            }
        });
        this.func_185043_a(new ResourceLocation("pulling"), (stack, worldIn, entityIn) ->
                entityIn != null && entityIn.func_184587_cr() && entityIn.func_184607_cu() == stack ? 1.0F : 0.0F
        );

    }

    private boolean isBroadHead(ItemStack stack) {
        return !stack.func_190926_b() && stack.func_77973_b() instanceof ItemBroadheadArrow;
    }

    @Override
    protected boolean func_185058_h_(ItemStack stack) {
        return isBroadHead(stack) || super.func_185058_h_(stack);
    }

    private ItemStack findAmmo(EntityPlayer player) {
        if (this.func_185058_h_(player.func_184586_b(EnumHand.OFF_HAND)))
            return player.func_184586_b(EnumHand.OFF_HAND);
        else if (this.func_185058_h_(player.func_184586_b(EnumHand.MAIN_HAND)))
            return player.func_184586_b(EnumHand.MAIN_HAND);
        else {
            IItemHandler inv = player.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, EnumFacing.UP);
            for (int i = 0; i < inv.getSlots(); ++i) {
                ItemStack itemstack = inv.getStackInSlot(i);
                if (this.func_185058_h_(itemstack))
                    return itemstack;
            }
            return ItemStack.field_190927_a;
        }
    }

    public float getArrowVelocity(ItemStack stack, int charge) {
        int max = isBroadHead(stack) ? 2 : 1;
        float f = charge / 20.0F;
        f = (f * f + f * 2.0F) / 3.0F;
        if (f > max)
            f = max;
        return f;
    }

    @Override
    public void func_77615_a(ItemStack stack, World worldIn, EntityLivingBase entityLiving, int timeLeft) {
        if (entityLiving instanceof EntityPlayer) {
            EntityPlayer player = (EntityPlayer) entityLiving;
            boolean flag = player.field_71075_bZ.field_75098_d || EnchantmentHelper.func_77506_a(Enchantments.field_185312_x, stack) > 0;
            ItemStack itemstack = this.findAmmo(player);

            int i = this.func_77626_a(stack) - timeLeft;
            i = net.minecraftforge.event.ForgeEventFactory.onArrowLoose(stack, worldIn, (EntityPlayer) entityLiving, i, !itemstack.func_190926_b() || flag);
            if (i < 0) return;

            if (!itemstack.func_190926_b() || flag) {
                if (itemstack .func_190926_b() ) {
                    itemstack = new ItemStack(Items.field_151032_g);
                }

                float velocity = getArrowVelocity(itemstack, i);

                if ((double) velocity >= 0.1D) {
                    boolean flag1 = player.field_71075_bZ.field_75098_d || (itemstack.func_77973_b() instanceof ItemArrow && ((ItemArrow) itemstack.func_77973_b()).isInfinite(itemstack, stack, player));

                    if (!worldIn.field_72995_K) {
                        ItemArrow itemarrow = (ItemArrow) (itemstack.func_77973_b() instanceof ItemArrow ? itemstack.func_77973_b() : Items.field_151032_g);
                        EntityArrow entityarrow = itemarrow.func_185052_a(worldIn, itemstack, player);
                        entityarrow.func_184547_a(player, player.field_70125_A, player.field_70177_z, 0.0F, velocity * 3.0F, 1.0F);

                        if (velocity >= 1.0F)
                            entityarrow.func_70243_d(true);

                        int j = EnchantmentHelper.func_77506_a(Enchantments.field_185309_u, stack);

                        if (j > 0) {
                            entityarrow.func_70239_b(entityarrow.func_70242_d() + (double) j * 0.5D + 0.5D);
                        }

                        int k = EnchantmentHelper.func_77506_a(Enchantments.field_185310_v, stack);

                        if (k > 0) {
                            entityarrow.func_70240_a(k);
                        }

                        if (EnchantmentHelper.func_77506_a(Enchantments.field_185311_w, stack) > 0) {
                            entityarrow.func_70015_d(100);
                        }

                        stack.func_77972_a(1, player);

                        if (flag1) {
                            entityarrow.field_70251_a = EntityArrow.PickupStatus.CREATIVE_ONLY;
                        }

                        worldIn.func_72838_d(entityarrow);
                    }

                    worldIn.func_184148_a(null, player.field_70165_t, player.field_70163_u, player.field_70161_v, SoundEvents.field_187737_v, SoundCategory.NEUTRAL, 1.0F, 1.0F / (field_77697_d.nextFloat() * 0.4F + 1.2F) + velocity * 0.5F);

                    if (!flag1) {
                        itemstack.func_190918_g(1);

                        if (itemstack.func_190916_E() == 0) {
                            player.field_71071_by.func_184437_d(itemstack);
                        }
                    }

                    player.func_71029_a(StatList.func_188057_b(this));
                }
            }
        }
    }
}
